use argh::FromArgs;

#[derive(FromArgs, PartialEq, Debug)]
/// owl cli
pub struct OwlCLI {
    #[argh(subcommand)]
    pub nested: OwlCLICommands,
}

#[derive(FromArgs, PartialEq, Debug)]
#[argh(subcommand)]
pub enum OwlCLICommands {
    List(ListCommand),
    Get(GetCommand),
    Store(StoreCommand),
}

#[derive(FromArgs, PartialEq, Debug)]
/// First subcommand.
#[argh(subcommand, name = "list")]
pub struct ListCommand {
    #[argh(option)]
    /// database
    pub db: Option<String>,

    #[argh(positional)]
    /// collection
    pub collection: Option<String>,
}

#[derive(FromArgs, PartialEq, Debug)]
/// First subcommand.
#[argh(subcommand, name = "store")]
pub struct StoreCommand {
    #[argh(option)]
    /// database
    pub db: Option<String>,

    #[argh(positional)]
    /// collection
    pub collection: String,
}

#[derive(FromArgs, PartialEq, Debug)]
/// Second subcommand.
#[argh(subcommand, name = "get")]
pub struct GetCommand {
    #[argh(option)]
    /// database
    pub db: Option<String>,

    #[argh(positional)]
    /// collection
    pub collection: String,

    #[argh(positional)]
    /// id
    pub id: String,
}
