use std::io::Read;

use owl::prelude::*;

// data points
/*

// events
struct Event {
    pub ts: String,
    pub content: String,
    pub references: Vec<Reference>,
    pub attachments: Vec<File>
}

pub struct File(String);
*/

// TODO : document

// TODO : serve api
// TODO : schemaless data storage (named)
// TODO : export/import?

// pub static PG: OnceCell<sqlx::PgPool> = OnceCell::const_new();

#[macro_export]
macro_rules! get_pg {
    () => {
        if let Some(client) = $crate::PG.get() {
            client
        } else {
            let client = sqlx::postgres::PgPoolOptions::new()
                .max_connections(5)
                .connect(&std::env::var("DATABASE_URL").unwrap())
                .await
                .unwrap();
            $crate::PG.set(client).unwrap();
            $crate::PG.get().unwrap()
        }
    };
}

/*

#[rocket::main]
async fn main() {
    let cors = rocket_cors::CorsOptions {
        allowed_origins: rocket_cors::AllowedOrigins::all(),
        allowed_methods: vec![Method::Get, Method::Post, Method::Options]
            .into_iter()
            .map(From::from)
            .collect(),
        allowed_headers: rocket_cors::AllowedHeaders::all(),
        allow_credentials: true,
        ..Default::default()
    }
    .to_cors()
    .expect("error creating CORS options");

    rocket::build()
        .mount(
            "/",
            route![
                routes::model_api_create,
                routes::model_api_info,
                routes::model_api_update,
                routes::model_overview
            ],
        )
        .attach(cors)
        //.manage(pg)
        .launch()
        .await
        .unwrap();
}
*/

mod cli;

pub fn main() {
    let cli: cli::OwlCLI = argh::from_env();

    match cli.nested {
        cli::OwlCLICommands::List(list_command) => {
            let db_path = list_command.db.unwrap_or("./db".to_string());
            let db = Database::filesystem(&db_path);
            if let Some(collection) = list_command.collection {
                let entries = db.list_entries(&collection);
                println!("List {db_path} [{collection}]:");
                for t in entries {
                    println!("   - {t}");
                }
            } else {
                let collections = db.list();
                println!("List {db_path}:");
                for c in collections {
                    println!("   - {c}");
                }
            }
        }
        cli::OwlCLICommands::Get(get_command) => {
            let db_path = get_command.db.unwrap_or("./db".to_string());
            let db = Database::filesystem(&db_path);

            let x: rmpv::Value = db.get_id(&get_command.collection, &get_command.id);
            println!("{}", serde_json::to_string(&x).unwrap());
        }
        cli::OwlCLICommands::Store(store_command) => {
            let db_path = store_command.db.unwrap_or("./db".to_string());
            let db = Database::filesystem(&db_path).named();

            let mut buffer = String::new();
            std::io::stdin()
                .read_to_string(&mut buffer)
                .expect("Failed to read from stdin");
            let json_value: serde_json::Value =
                serde_json::from_str(&buffer).expect("Failed to parse JSON");

            let id = json_value.id();
            unsafe {
                db.save_raw(&json_value, &store_command.collection);
            }

            println!("{}::{id}", store_command.collection);
        }
    }
}
